"""This module contains logic for a gameboard that doesnt calculate moves."""


class MappedGameBoard(object):
    """
    This class models a 2048 game board with a table of tiles holding numbers.

    The board is modeled by a 64 bit integer and all tile, row, column lookups
    are performed using static maps loaded on startup.
    """
    # # /**
    # #  * Return a value indicating whether the board has an upward move or not
    # #  * @return true if the board can move up, false otherwise
    # #  */
    # # public boolean canMoveUp()
    # # {
    # #     return moveMap.hasBackwardMove(getColumn(0)) ||
    # #             moveMap.hasBackwardMove(getColumn(1)) ||
    # #             moveMap.hasBackwardMove(getColumn(2)) ||
    # #             moveMap.hasBackwardMove(getColumn(3))
    # # }
    # #
    # # /**
    # #  * Return a value indicating whether the board has a downward move or not
    # #  * @return true if the board can move down, false otherwise
    # #  */
    # # public boolean canMoveDown()
    # # {
    # #     return moveMap.hasForwardMove(getColumn(0)) ||
    # #             moveMap.hasForwardMove(getColumn(1)) ||
    # #             moveMap.hasForwardMove(getColumn(2)) ||
    # #             moveMap.hasForwardMove(getColumn(3))
    # # }
    # #
    # # /**
    # #  * Return a value indicating whether the board has a leftward move or not
    # #  * @return true if the board can move left, false otherwise
    # #  */
    # # public boolean canMoveLeft()
    # # {
    # #     return moveMap.hasBackwardMove(getRow(0)) ||
    # #             moveMap.hasBackwardMove(getRow(1)) ||
    # #             moveMap.hasBackwardMove(getRow(2)) ||
    # #             moveMap.hasBackwardMove(getRow(3))
    # # }
    # #
    # # /**
    # #  * Return a value indicating whether the board has a rightward move or not
    # #  * @return true if the board can move right, false otherwise
    # #  */
    # # public boolean canMoveRight()
    # # {
    # #     return moveMap.hasForwardMove(getRow(0)) ||
    # #             moveMap.hasForwardMove(getRow(1)) ||
    # #             moveMap.hasForwardMove(getRow(2)) ||
    # #             moveMap.hasForwardMove(getRow(3))
    # # }
    # #
    # # /**
    # #  * Return a boolean determining if there are any moves on the board
    # #  * @return true if there is a move left, false otherwise
    # #  */
    # # public boolean canMove()
    # # {
    # # 	return canMoveLeft() || canMoveRight() || canMoveUp() || canMoveDown()
    # # }
    # #
    # # /**
    # #  * Move the pieces up on the game board and increment the score
    # #  */
    # # public void moveUp()
    # # {
    # #     short cOne = getColumn(0)
    # #     score += moveMap.getBackwardScoreFrom(cOne)
    # #     placeColumn(0, moveMap.getBackwardMoveFrom(cOne))
    # #
    # #     short cTwo = getColumn(1)
    # #     score += moveMap.getBackwardScoreFrom(cTwo)
    # #     placeColumn(1, moveMap.getBackwardMoveFrom(cTwo))
    # #
    # #     short cThr = getColumn(2)
    # #     score += moveMap.getBackwardScoreFrom(cThr)
    # #     placeColumn(2, moveMap.getBackwardMoveFrom(cThr))
    # #
    # #     short cFou = getColumn(3)
    # #     score += moveMap.getBackwardScoreFrom(cFou)
    # #     placeColumn(3, moveMap.getBackwardMoveFrom(cFou))
    # # }
    # #
    # # /**
    # #  * Move the pieces down on the game board and increment the score
    # #  */
    # # public void moveDown()
    # # {
    # #     short cOne = getColumn(0)
    # #     score += moveMap.getForwardScoreFrom(cOne)
    # #     placeColumn(0, moveMap.getForwardMoveFrom(cOne))
    # #
    # #     short cTwo = getColumn(1)
    # #     score += moveMap.getForwardScoreFrom(cTwo)
    # #     placeColumn(1, moveMap.getForwardMoveFrom(cTwo))
    # #
    # #     short cThr = getColumn(2)
    # #     score += moveMap.getForwardScoreFrom(cThr)
    # #     placeColumn(2, moveMap.getForwardMoveFrom(cThr))
    # #
    # #     short cFou = getColumn(3)
    # #     score += moveMap.getForwardScoreFrom(cFou)
    # #     placeColumn(3, moveMap.getForwardMoveFrom(cFou))
    # # }
    # #
    # # /**
    # #  * Move the pieces left on the game board and increment the score
    # #  */
    # # public void moveLeft()
    # # {
    # #     short rOne = getRow(0)
    # #     score += moveMap.getBackwardScoreFrom(rOne)
    # #     placeRow(0, moveMap.getBackwardMoveFrom(rOne))
    # #
    # #     short rTwo = getRow(1)
    # #     score += moveMap.getBackwardScoreFrom(rTwo)
    # #     placeRow(1, moveMap.getBackwardMoveFrom(rTwo))
    # #
    # #     short rThr = getRow(2)
    # #     score += moveMap.getBackwardScoreFrom(rThr)
    # #     placeRow(2, moveMap.getBackwardMoveFrom(rThr))
    # #
    # #     short rFou = getRow(3)
    # #     score += moveMap.getBackwardScoreFrom(rFou)
    # #     placeRow(3, moveMap.getBackwardMoveFrom(rFou))
    # # }
    # #
    # # /**
    # #  * Move the pieces right on the game board and increment the score
    # #  */
    # # public void moveRight()
    # # {
    # #     short rOne = getRow(0)
    # #     score += moveMap.getForwardScoreFrom(rOne)
    # #     placeRow(0, moveMap.getForwardMoveFrom(rOne))
    # #
    # #     short rTwo = getRow(1)
    # #     score += moveMap.getForwardScoreFrom(rTwo)
    # #     placeRow(1, moveMap.getForwardMoveFrom(rTwo))
    # #
    # #     short rThr = getRow(2)
    # #     score += moveMap.getForwardScoreFrom(rThr)
    # #     placeRow(2, moveMap.getForwardMoveFrom(rThr))
    # #
    # #     short rFou = getRow(3)
    # #     score += moveMap.getForwardScoreFrom(rFou)
    # #     placeRow(3, moveMap.getForwardMoveFrom(rFou))
    # # }
    # #
    # # /**
    # #  * Move the pieces up on the game board. If the  move isn't possible then return false and
    # #  * leave the game in its current state.
    # #  * @return true if the move occurred, false otherwise
    # #  */
    # # public boolean tryMoveUp()
    # # {
    # # 	if (canMoveUp())
    # # 	{
    # #         # get the matrix of moves
    # #         int[][] moveMatrix = LikeValueIndexMapper.getUpMovementMatrixFor(this)
    # #         # store the old score (for the handler)
    # #         int oldScore = score
    # #         # make the move
    # # 		moveUp()
    # #         # if there is a handler, pass the event
    # #         if (handler != null)
    # #         {
    # #             boolean didScore = score > oldScore
    # #             # pass event to handler
    # #             handler.didMoveUp(didScore, moveMatrix)
    # #         }
    # # 		return true
    # # 	}
    # # 	return false
    # # }
    # #
    # # /**
    # #  * Move the pieces down on the game board. If the  move isn't possible then return false and
    # #  * leave the game in its current state.
    # #  * @return true if the move occurred, false otherwise
    # #  */
    # # public boolean tryMoveDown()
    # # {
    # # 	if (canMoveDown())
    # # 	{
    # #         # get the matrix of moves
    # #         int[][] moveMatrix = LikeValueIndexMapper.getDownMovementMatrixFor(this)
    # #         # store the old score (for the handler)
    # #         int oldScore = score
    # #         # make the move
    # # 		moveDown()
    # #         # if there is a handler, pass the event
    # #         if (handler != null)
    # #         {
    # #             boolean didScore = score > oldScore
    # #             # pass event to handler
    # #             handler.didMoveDown(didScore, moveMatrix)
    # #         }
    # # 		return true
    # # 	}
    # # 	return false
    # # }
    # #
    # # /**
    # #  * Move the pieces left on the game board. If the  move isn't possible then return false and
    # #  * leave the game in its current state.
    # #  * @return true if the move occurred, false otherwise
    # #  */
    # # public boolean tryMoveLeft()
    # # {
    # # 	if (canMoveLeft())
    # # 	{
    # #         # get the matrix of moves
    # #         int[][] moveMatrix = LikeValueIndexMapper.getLeftMovementMatrixFor(this)
    # #         # store the old score (for the handler)
    # #         int oldScore = score
    # #         # make the move
    # # 		moveLeft()
    # #         # if there is a handler, pass the event
    # #         if (handler != null)
    # #         {
    # #             boolean didScore = score > oldScore
    # #             # pass event to handler
    # #             handler.didMoveLeft(didScore, moveMatrix)
    # #         }
    # # 		return true
    # # 	}
    # # 	return false
    # # }
    # #
    # # /**
    # #  * Move the pieces right on the game board. If the  move isn't possible then return false and
    # #  * leave the game in its current state.
    # #  * @return true if the move occurred, false otherwise
    # #  */
    # # public boolean tryMoveRight()
    # # {
    # # 	if (canMoveRight())
    # # 	{
    # #         # get the matrix of moves
    # #         int[][] moveMatrix = LikeValueIndexMapper.getRightMovementMatrixFor(this)
    # #         # store the old score (for the handler)
    # #         int oldScore = score
    # #         # make the move
    # # 		moveRight()
    # #         # if there is a handler, pass the event
    # #         if (handler != null)
    # #         {
    # #             boolean didScore = score > oldScore
    # #             # pass event to handler
    # #             handler.didMoveRight(didScore, moveMatrix)
    # #         }
    # # 		return true
    # # 	}
    # # 	return false
    # # }
