"""This module contains the logic for a 2048 gameboard."""
from tfe_engine import GameBoard


class TwentyFortyEight(GameBoard):
    """This class adds 2048 specific logic to the GameBoard class."""

    def __init__(self, delegate=None):
        """Create a new 2048 game."""
        super(TwentyFortyEight, self).__init__(delegate)
        self.start_new()

    def start_new(self):
        """Reset the tiles and randomly place 2 tiles."""
        self.reset()
        self.place_random_tile()
        self.place_random_tile()

    def move_up(self):
        """Move the pieces up on the game board and add a new tile."""
        if super(TwentyFortyEight, self).move_up():
            self.place_random_tile()
            return True
        return False

    def move_down(self):
        """Move the pieces down on the game board and add a new tile."""
        if super(TwentyFortyEight, self).move_down():
            self.place_random_tile()
            return True
        return False

    def move_left(self):
        """Move the pieces left on the game board and add a new tile."""
        if super(TwentyFortyEight, self).move_left():
            self.place_random_tile()
            return True
        return False

    def move_right(self):
        """Move the pieces right on the game board and add a new tile."""
        if super(TwentyFortyEight, self).move_right():
            self.place_random_tile()
            return True
        return False
